package cz.vutbr.fit.gja.AndroidStatus;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.BatteryManager;
import android.os.Build;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;

public class Status extends AppCompatActivity {

    private TextView batteryTxt;
    private ProgressBar batteryBar;
    private TextView deviceDataTxt;

    private BroadcastReceiver mBatInfoReceiver = new BroadcastReceiver(){
        @Override
        public void onReceive(Context ctxt, Intent intent) {
            // získání kapacity baterie (v %)
            int level = intent.getIntExtra(BatteryManager.EXTRA_LEVEL, 0);

            // nastavení výpisu hodnoty do progressbaru a textview
            batteryTxt.setText(String.valueOf(level) + " %");
            batteryBar.setProgress(level);
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_status);

        // získání instancí UI elementů na pro zobrazení dat
        batteryTxt = this.findViewById(R.id.txtDataBattery);
        batteryBar = this.findViewById(R.id.barBattery);
        deviceDataTxt = this.findViewById(R.id.txtDataDevice);

        // nastavení názvu zařízení
        deviceDataTxt.setText(Build.MANUFACTURER.toUpperCase() + " " + Build.MODEL);

        // registrace příjmu příjmu dat o změně kapacity baterie
        this.registerReceiver(this.mBatInfoReceiver, new IntentFilter(Intent.ACTION_BATTERY_CHANGED));

    }

    public void onClickBtn(View view) {
        Intent myIntent = new Intent(Status.this, LocationActivity.class);
        Status.this.startActivity(myIntent);
    }

}
