import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;


public class RMIClient {
    public static void main(String[] args) throws RemoteException, NotBoundException{
        Registry myRegistry = LocateRegistry.getRegistry("127.0.0.1", 1099); // Get RMI registry from server
                                                                            // localhost in this case, bound to port 1099 (see RMIServer.java)
        
        RMIServerInterface server = (RMIServerInterface) myRegistry.lookup("myRMI"); // Get server stub by looking up "myRMI" in RMI registry
        System.out.println(server.respond());   // Call remote method
    }
}
