import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

public class RMIServer extends UnicastRemoteObject implements RMIServerInterface { // UnicastRemoteObject makes server run indefinitely
    public RMIServer() throws RemoteException{    // Constructor throws RemoteException if it fails  
    };
    
    @Override
    public String respond() throws RemoteException {    // Implementation for remotely callable method
        return "String returned from server";   // Simply returns a string
    }
    
    public static void main(String[] args){
        try{
            Registry registry = LocateRegistry.createRegistry(1099); // Create RMI registry on port 1099
            registry.rebind("myRMI", new RMIServer());      // Bind RMIServer object to registry under name "myRMI"
        }
        catch(RemoteException e){   // Both createRegistry and rebing can throw RemoteException
            e.printStackTrace();
        }
    }
}
