package cz.vutbr.fit.gja;

import cz.vutbr.fit.gja.inheritance.Person;

/**
 * Generics student class
 * This class is used as reference class for some other examples 
 *
 */
public class Student extends Person {

	/**
	 * Helper field. This is used as instance counter to demonstrate actual number of instances that are created
	 */
	private static int studentsCreated = 0;
	
	/**
	 * Order of creation starting with 0
	 */
	public final int ID;
	
	/**
	 * Private field for student name 
	 */
	private String name;

	public String getName() {
		return name;
	}
	
	public Student() {
		ID = studentsCreated++;
	}
	

	public void setName(String name) {
		this.name = name;
	}

	public void displayName() {
		System.out.println("Name: " + name);
	}
}
