package cz.vutbr.fit.gja.annotationBasedConfiguration;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Required;

public class Student {
	private Integer age;
	private String name;
	
	/**
	 * Autowiring School object by its bean name
	 * Qualifier is used to prevent messing up the name, as many "School" beans might exist in the workplace 
	 */
	@Autowired
	@Qualifier("school")
	private School school;

	@Required
	public void setAge(Integer age) {
		this.age = age;
	}

	public Integer getAge() {
		return age;
	}

	@Required
	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public School getSchool() {
		return school;
	}
	
	public void setSchool(School school) {
		this.school = school;
	}

	public void displaySchoolName() {
		school.displayName();
	}

	/**
	 * Shows detailed informations regarding the current student instance.
	 * This shows which school is actually autowired here 
	 */
	public void showInfo() {
		System.out.println("Student name: " + name);
		System.out.println("Student age: " + age);
		System.out.println("Students school: " + school);
		

	}
}
