package cz.vutbr.fit.gja.autoWiring;

import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Basic autowiring example that usess local Beans.xml file and demonstrated different autowiring methods.
 * It also shows how wired objects are wired by instances
 *
 */
public class AutowiringExample {
	public static void main(String[] args) {
		
		// Create the context
		AbstractApplicationContext context = new ClassPathXmlApplicationContext("cz/vutbr/fit/gja/autoWiring/Beans.xml");
		
		// Create basic Student that is not wired at all. The School object will be referenced other way 
		Student unwiredStudent = (Student) context.getBean("student-unwired");
		unwiredStudent.displaySchoolName();
		
		// Create Student wired by name 
		Student studentWiredByName = (Student) context.getBean("student-wired-byname");
		studentWiredByName.displaySchoolName();

		// Create student wired by type
		Student studentWiredByType = (Student) context.getBean("student-wired-bytype");
		studentWiredByType.displaySchoolName();

	}
}
