package cz.vutbr.fit.gja.collectionInjection;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

/**
 * Basic School object
 *
 */
public class School {

	/**
	 * List of strings, but for making it safe, any class is allowed
	 */
	List<?> students;

	/**
	 * Map of strings, also making it safe by allowing any class as both key and value
	 */
	public Map<?, ?> courses;

	public List<?> getStudents() {
		return students;
	}

	public void setStudents(List<?> students) {
		this.students = students;
	}

	public Map<?, ?> getCourses() {
		return courses;
	}

	public void setCourses(Map<?, ?> courses) {
		this.courses = courses;
	}

	/**
	 * Basic iteration through the list of objects
	 */
	public void showStudents() {
		System.out.println("Students: ");
		for (Object student : students) {
			System.out.println("\t" + student.toString());
		}
	}

	/**
	 * Printing courses by key-value principle
	 */
	public void showCourses() {
		System.out.println("Courses: ");
		for (Entry<?, ?> course : courses.entrySet()) { // Key and Value are objects in general
			System.out.println("\t" + course.getKey().toString() + ":");
			if (course.getValue() instanceof Iterable) { // If the Value is iterable, print its contents, otherwise it's just a common object
				for (Object student : (Iterable<?>) course.getValue()) {
					System.out.println("\t\t" + student.toString());
				}
			} else { // Value is not a list, which indicates error in the map definition 
				System.err.println("\t\t" + course.getValue().toString());
			}
		}
	}

}
