package cz.vutbr.fit.gja.dependencyInjection;

import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Basic dependency injection.
 * Beans are loaded from local Beans.xml
 *
 */
public class DependencyInjectionExample {
	public static void main(String[] args) {
		AbstractApplicationContext context = new ClassPathXmlApplicationContext("cz/vutbr/fit/gja/dependencyInjection/Beans.xml");
		
		// Load first book and print it's contents to verify that the owner was assigned
		Book book = (Book) context.getBean("book");
		book.showOwner();

		// Load the next book and do the same as above
		AnotherBook anotherBook = (AnotherBook) context.getBean("another-book");
		anotherBook.showOwner();
	}
}
