package cz.vutbr.fit.gja.inheritance;

import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

/**
 * Basic inheritance example.
 * Configurations are loaded from configuration beans file
 *
 */
public class BeanInheritanceExample {

	public static void main(String[] args) {
		// Load bean factory
		Resource resource = new ClassPathResource("cz/vutbr/fit/gja/inheritance/BeansConfigurations.xml");
		BeanFactory factory = new XmlBeanFactory(resource);

		// Create the first person and show age
		Person person = (Person) factory.getBean("person");
		person.displayAge();

		// Create student and show inherited age
		Student student = (Student) factory.getBean("student");
		student.displayName();
		student.displayAge();

		// Create another student and show overriden age
		Student olderStudent = (Student) factory.getBean("olderstudent");
		olderStudent.displayName();
		olderStudent.displayAge();

	}

}
