<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Get and set properties Example</title>
    </head>

    <body>

        <!-- 
        The useBean action declares a JavaBean for use in a JSP. Once declared, 
        the bean becomes a scripting variable that can be accessed by both 
        scripting elements and other custom tags used in the JSP.
        -->
        
        <h2>Example of using the jsp:useBean action</h2>
        
        <!-- The class attribute defines the path to the java class to be used, 
        id attribute defines the name of the bean -->
        <jsp:useBean id = "date" class = "java.util.Date" /> 
        <!-- it is possible to use bean date, becaue it is defined in previous 
        step by jsp:useBean construct-->
        <p>The date/time is <%= date%></p>

        <!-- Along with jsp:useBean action, you can use the jsp:getProperty action 
        to access the get methods and the jsp:setProperty action to access the set methods. -->
        <jsp:useBean id = "students" class = "cz.vutbr.fit.gja.jsp.StudentsBean"> 
            <jsp:setProperty name = "students" property = "firstName" value = "John"/>
            <jsp:setProperty name = "students" property = "lastName" value = "Doe"/>
        </jsp:useBean>

        <p>Student First Name: 
            <jsp:getProperty name = "students" property = "firstName"/>
        </p>

        <p>Student Last Name: 
            <jsp:getProperty name = "students" property = "lastName"/>
        </p>
        
        <!-- The include directive inserts another file into the file -->
        <%@ include file="/include/backToMainPage.jsp" %>
    </body>
</html>
