<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ page import = "java.io.*,java.util.*" %>
<!DOCTYPE html>
<!--
JSP makes use of the servlet provided HttpSession Interface. This interface 
provides a way to identify a user. By default, JSPs have session tracking 
enabled and a new HttpSession object is instantiated for each new client 
automatically. Disabling session tracking requires explicitly turning it 
off by setting the page directive session attribute to false. The JSP engine 
exposes the HttpSession object to the JSP author through the implicit 
session object.
-->
<%
    // Get session creation time.
    Date createTime = new Date(session.getCreationTime());

    // Get last access time of this Webpage.
    Date lastAccessTime = new Date(session.getLastAccessedTime());

    String title = "Welcome Back to my website";
    Integer visitCount = new Integer(0);
    String visitCountKey = new String("visitCount");
    String userIDKey = new String("userID");
    String userID = new String("ABCD");

    // Check if this is new comer on your Webpage.
    if (session.isNew()) {
        title = "Welcome to my website";
        session.setAttribute(userIDKey, userID);
        session.setAttribute(visitCountKey, visitCount);
    }
    visitCount = (Integer) session.getAttribute(visitCountKey);
    if (visitCount == null) {
        visitCount = 0;
    }
    visitCount = visitCount + 1;
    userID = (String) session.getAttribute(userIDKey);
    session.setAttribute(visitCountKey, visitCount);
%>

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Session Tracking</title>
    </head>

    <body>
    <center>
        <h1><%= title%></h1>
    </center>

    <table align="center" border="1"> 
        <tr>
            <th>Session info</th>
            <th>Value</th>
        </tr> 
        <tr>
            <td>id</td>
            <!-- The out implicit object is an instance of a javax.servlet.jsp.JspWriter 
            object and is used to send content in a response. Equivalent to this is 
            <%= session.getId()%> -->
            <td><% out.print(session.getId()); %></td>
        </tr> 
        <tr>
            <td>Creation Time</td>
            <td><% out.print(createTime); %></td>
        </tr> 
        <tr>
            <td>Time of Last Access</td>
            <td><% out.print(lastAccessTime); %></td>
        </tr> 
        <tr>
            <td>User ID</td>
            <td><% out.print(userID); %></td>
        </tr> 
        <tr>
            <td>Number of visits</td>
            <td><% out.print(visitCount);%></td>
        </tr> 
    </table> 

    <!-- The include directive inserts another file into the file -->
    <%@ include file="/include/backToMainPage.jsp" %>
</body>
</html>
