package cz.vutbr.fit.gja.primefaces;

import cz.vutbr.fit.gja.primefaces.autocomplete.Theme;
import cz.vutbr.fit.gja.primefaces.autocomplete.ThemeService;
import java.util.ArrayList;
import java.util.List;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.context.FacesContext;
import org.primefaces.event.SelectEvent;


@ManagedBean(name = "autocompleteBean")
public class AutocompleteBean {

    private String txt1;
    private String txt2;
    private String txt3;
    private String txt4;
    private String txt5;
    private String txt6;
    private String txt7;
    private String txt8;
    private Theme theme1;
    private Theme theme2;
    private Theme theme3;
    private Theme theme4;
    private List<Theme> selectedThemes;
     
    @ManagedProperty("#{themeService}")
    private ThemeService service;
    
    /**
     * Method returns 10 autocomplete results based on query.
     * @param query input string which is used as a base for autocomplete result
     * @return list of autocomlete results
     */
    public List<String> completeText(String query) {
        List<String> results = new ArrayList<String>();
        for(int i = 0; i < 10; i++) {
            results.add(query + i);
        }
         
        return results;
    }
    
    /**
     * Method returns Themes that contains text in query.
     * @param query input string which is used as a base for autocomplete result
     * @return list of Themes containing content of query in its name
     */
    public List<Theme> completeTheme(String query) {
        List<Theme> allThemes = service.getThemes();
        List<Theme> filteredThemes = new ArrayList<Theme>();
         
        for (int i = 0; i < allThemes.size(); i++) {
            Theme skin = allThemes.get(i);
            if(skin.getName().toLowerCase().contains(query)) {
                filteredThemes.add(skin);
            }
        }
         
        return filteredThemes;
    }
     
    public void onItemSelect(SelectEvent event) {
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Item Selected", event.getObject().toString()));
    }
    
    /**
     * Method used to determine the Theme group based on its names first letter.
     * @param theme the Theme whichs group is determined
     * @return character representing the Themes group
     */
    public char getThemeGroup(Theme theme) {
        return theme.getDisplayName().charAt(0);
    }
    
    /* Getters and Setters */
    
    /**
     * @return the txt1
     */
    public String getTxt1() {
        return txt1;
    }

    /**
     * @param txt1 the txt1 to set
     */
    public void setTxt1(String txt1) {
        this.txt1 = txt1;
    }

    /**
     * @return the txt2
     */
    public String getTxt2() {
        return txt2;
    }

    /**
     * @param txt2 the txt2 to set
     */
    public void setTxt2(String txt2) {
        this.txt2 = txt2;
    }

    /**
     * @return the txt3
     */
    public String getTxt3() {
        return txt3;
    }

    /**
     * @param txt3 the txt3 to set
     */
    public void setTxt3(String txt3) {
        this.txt3 = txt3;
    }

    /**
     * @return the txt4
     */
    public String getTxt4() {
        return txt4;
    }

    /**
     * @param txt4 the txt4 to set
     */
    public void setTxt4(String txt4) {
        this.txt4 = txt4;
    }

    /**
     * @return the txt5
     */
    public String getTxt5() {
        return txt5;
    }

    /**
     * @param txt5 the txt5 to set
     */
    public void setTxt5(String txt5) {
        this.txt5 = txt5;
    }

    /**
     * @return the txt6
     */
    public String getTxt6() {
        return txt6;
    }

    /**
     * @param txt6 the txt6 to set
     */
    public void setTxt6(String txt6) {
        this.txt6 = txt6;
    }

    /**
     * @return the txt7
     */
    public String getTxt7() {
        return txt7;
    }

    /**
     * @param txt7 the txt7 to set
     */
    public void setTxt7(String txt7) {
        this.txt7 = txt7;
    }

    /**
     * @return the txt8
     */
    public String getTxt8() {
        return txt8;
    }

    /**
     * @param txt8 the txt8 to set
     */
    public void setTxt8(String txt8) {
        this.txt8 = txt8;
    }

    /**
     * @return the theme1
     */
    public Theme getTheme1() {
        return theme1;
    }

    /**
     * @param theme1 the theme1 to set
     */
    public void setTheme1(Theme theme1) {
        this.theme1 = theme1;
    }

    /**
     * @return the theme2
     */
    public Theme getTheme2() {
        return theme2;
    }

    /**
     * @param theme2 the theme2 to set
     */
    public void setTheme2(Theme theme2) {
        this.theme2 = theme2;
    }

    /**
     * @return the theme3
     */
    public Theme getTheme3() {
        return theme3;
    }

    /**
     * @param theme3 the theme3 to set
     */
    public void setTheme3(Theme theme3) {
        this.theme3 = theme3;
    }

    /**
     * @return the theme4
     */
    public Theme getTheme4() {
        return theme4;
    }

    /**
     * @param theme4 the theme4 to set
     */
    public void setTheme4(Theme theme4) {
        this.theme4 = theme4;
    }

    /**
     * @return the selectedThemes
     */
    public List<Theme> getSelectedThemes() {
        return selectedThemes;
    }

    /**
     * @param selectedThemes the selectedThemes to set
     */
    public void setSelectedThemes(List<Theme> selectedThemes) {
        this.selectedThemes = selectedThemes;
    }

    /**
     * @param service the service to set
     */
    public void setService(ThemeService service) {
        this.service = service;
    }
}
