package cz.vutbr.fit.gja.primefaces.datatable;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
 
@ManagedBean(name = "carService")
@ApplicationScoped
public class CarService {
     
    private final static String[] COLORS;
     
    private final static String[] BRANDS;
     
    static {
        COLORS = new String[10];
        COLORS[0] = "Black";
        COLORS[1] = "White";
        COLORS[2] = "Green";
        COLORS[3] = "Red";
        COLORS[4] = "Blue";
        COLORS[5] = "Orange";
        COLORS[6] = "Silver";
        COLORS[7] = "Yellow";
        COLORS[8] = "Brown";
        COLORS[9] = "Maroon";
         
        BRANDS = new String[10];
        BRANDS[0] = "BMW";
        BRANDS[1] = "Mercedes";
        BRANDS[2] = "Volvo";
        BRANDS[3] = "Audi";
        BRANDS[4] = "Renault";
        BRANDS[5] = "Fiat";
        BRANDS[6] = "Volkswagen";
        BRANDS[7] = "Honda";
        BRANDS[8] = "Jaguar";
        BRANDS[9] = "Ford";
    }
     
    /**
     * Creates list of cars with random properties
     * @param size size of the list
     * @return the list of cars
     */
    public List<Car> createCars(int size) {
        List<Car> list = new ArrayList<Car>();
        for(int i = 0 ; i < size ; i++) {
            list.add(new Car(getRandomId(), getRandomBrand(), getRandomColor(), getRandomYear(), getRandomPrice()));
        }
         
        return list;
    }
     
    private String getRandomId() {
        return UUID.randomUUID().toString().substring(0, 8);
    }
     
    private int getRandomYear() {
        return (int) (Math.random() * 50 + 1960);
    }
     
    private String getRandomColor() {
        return COLORS[(int) (Math.random() * 10)];
    }
     
    private String getRandomBrand() {
        return BRANDS[(int) (Math.random() * 10)];
    }
     
    public int getRandomPrice() {
        return (int) (Math.random() * 100000);
    }
     
    public List<String> getColors() {
        return Arrays.asList(COLORS);
    }
     
    public List<String> getBrands() {
        return Arrays.asList(BRANDS);
    }
}
