package cz.vutbr.fit.gja.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Example of simple Hello World servlet
 *
 * @author xhorna01@stud.fit.vutbr.cz
 */
public class HelloWorldServlet extends HttpServlet {

    /**
     * serialVersionUID is used during deserialization for verification
     */
    private static final long serialVersionUID = 424242424242L;

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @param msg string specifying which HTTP method was called
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response, String msg)
            throws ServletException, IOException {
        
        response.setContentType("text/html;charset=UTF-8");
        
        /*  The actual response page is created by writing the html to te PrintWriter, 
            that is provided to us by the getWriter() method of HttpServletResponse */
        try (PrintWriter out = response.getWriter()) {
            String name = request.getParameter("name");
            
            out.write("<H1>Hello " + name + "</H1>");
            out.write("<p>The HTTP " + msg + " method was called.</p>");
        }
    }

    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response, "GET");
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response, "POST");
    }
}
